/* TICK.C test local clock 

This program is provided to determine the QUANTUM, which is the
smallest time interval that the local machine can measure.  Tick is a
simple program; it should work on any Unix machine. It calls
gettimeofday() repeatedly. Then it prints out the value of each call
and the differences between each call & the previous. To use:

make tick
tick | more

Note that it would be completely wrong to print the result of each
gettimeofday after calling it. It turns out that the printing takes so
long that it distorts the results, making QUANTUM appear too large. Of
course the gettimeofday itself takes a long time; but that cannot be
helped.

  */

#define COUNT 1000

#include <stdio.h>
#include <sys/time.h>

main()
{
  struct timeval vals[COUNT], *tvp, *tvo, *tve;
  float avg ;
  tve=vals + COUNT ;

  for ( tvp=vals; tvp < tve; tvp++ )
    gettimeofday( tvp, (struct timezone*) 0);

  printf( "seconds     micros    diff(micros)\n");

  for ( tvp=vals+1; tvp < tve; tvp++ )
    {
      tvo=tvp-1;
      printf( "%d   %d    %d  \n", tvp->tv_sec, tvp->tv_usec,
	     (tvp->tv_sec - tvo->tv_sec)*1000000 + tvp->tv_usec - tvo->tv_usec );
    }


  tvo=vals; tve-- ;
  avg= (float) ((tve->tv_sec - tvo->tv_sec)*1000000 + tve->tv_usec - tvo->tv_usec )/ (float) COUNT;
  printf( "\n\n Mean time per test: %.1f microsecs\n", avg);
}
